%%  lsg_regelung_ini.m
%%  Kap 11.7.4
%%  Initialisierungsdatei zu lsg_regelung.mdl

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Es handelt sich hier nicht um ein technisches System, sondern um
% ein fiktives System, an dem der Regelungsentwurf in Matlab und die
% Simulation in Simulink eingebt werden soll
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Tstop = 10;
max_step = 0.01;

% Regelstrecke
z = [1 1];                    % zeros
p = [-2 -3+10*i -3-10*i];     % poles
g = 2;                        % gain

% Rckfhrung des Systems (dies ist noch kein Regler !!!)
num = 2;
den = [0.02 1];

% Verstrkung
verst = 100;

% Rauschen
Q = 1e-3;     % Varianz des Prozerauschens
R = 1e-3;     % Varianz des Merauschens

% Kalmanfilterentwurf

[A,B,C,D] = linmod('system_bsp');        % Systemmatrizen extrahieren
sys_strecke = ss(A,B,C,D);               % ss-Objekt erstellen
sys = ss(A,[B B],C,D);                   % ss-Objekt mit Rausch-Bercksichtigung
[kest, L, P] = kalman(sys,Q,R);          % Kalman-Filter entwerfen

% Zustandsreglerentwurf durch LQ-Optimierung
% Entwurf durch den Befehl lqry

Q_lq = 1;                                % Gewichtsmatrix der Zustnde
R_lq = 0.1;                              % Gewichtsmatrix der Stellgren
[k S e] = lqry(sys_strecke,Q_lq,R_lq);   % LQR-Reglerentwurf
Kv = -1/(C*inv(A-B*k)*B);                % Vorfaktor fr stationre Genauigkeit

% Simulation starten
sim('lsg_regelung')

% Ergebnis darstellen
figure; subplot(2,2,1)
plot(t,y);xlabel('Zeit [s]');title('gemessener Ausgang')
subplot(2,2,2)
plot(t,ye);xlabel('Zeit [s]');title('geschtzter Ausgang')
% print -depsc sprung_kalman.eps
