%%  gnmbeobs_i.m
%%  Kap 11.4.2
%%  Initialisierungsdatei fr Strgren-Beobachter

%% Maschinen- und allgemeine Simulationsdaten
gnm_i                                         % Gleichstrommaschine
gnmbeob_i                                     % Grundeinstellung

%% Strgren-Beobachter
F = [ 0 -1/(2*pi*J) 0 ]'  ;                   % Eingriff der Strung
s = 100 ;                                     % Rckfhrkoeffizient
polo = 5*real(pole(sys))+imag(pole(sys))/5*i  % Beobachterpole
l    = place (sys.a',sys.c',polo).'           % Rckfhrvektor berechnen

% Beobachter-Matrizen berechnen
% Zustzlich Ausgabe der Zustnde in Simulink -> beob.c, beob.dS
clear beob
beob.a = [ sys.a-l*sys.c F ; -s*sys.c 0 ] ;
beob.b = [ sys.b l ; 0 s ] ;
beob.c = [ sys.c 0 ; eye(size(beob.a)) ] ;
beob.d = zeros(size(beob.c*beob.b)) ;
beob   = ss(beob.a,beob.b,beob.c,beob.d)      % SS-LTI-Modell Beobachter
